/*
memallocfree3_gpu.cu (CUDA)

alloc and free
(3) output data
*/

#include "ofd.h"
#include "ofd_cuda.h"
#include "ofd_prototype.h"

void memalloc3_gpu()
{
	// near field full (complex)
	if ((NN > 0) && (NFreq2 > 0)) {
		// freed in calcNear3d()
		size_t size = NN * NFreq2 * sizeof(real_t);
		Ex_r = (real_t *)malloc(size);
		Ey_r = (real_t *)malloc(size);
		Ez_r = (real_t *)malloc(size);
		Hx_r = (real_t *)malloc(size);
		Hy_r = (real_t *)malloc(size);
		Hz_r = (real_t *)malloc(size);
		Ex_i = (real_t *)malloc(size);
		Ey_i = (real_t *)malloc(size);
		Ez_i = (real_t *)malloc(size);
		Hx_i = (real_t *)malloc(size);
		Hy_i = (real_t *)malloc(size);
		Hz_i = (real_t *)malloc(size);

		memset(Ex_r, 0, size);
		memset(Ey_r, 0, size);
		memset(Ez_r, 0, size);
		memset(Hx_r, 0, size);
		memset(Hy_r, 0, size);
		memset(Hz_r, 0, size);
		memset(Ex_i, 0, size);
		memset(Ey_i, 0, size);
		memset(Ez_i, 0, size);
		memset(Hx_i, 0, size);
		memset(Hy_i, 0, size);
		memset(Hz_i, 0, size);

		// freed in memfree2_gpu()
		cuda_malloc(GPU, UM, (void **)&d_Ex_r, size);
		cuda_malloc(GPU, UM, (void **)&d_Ey_r, size);
		cuda_malloc(GPU, UM, (void **)&d_Ez_r, size);
		cuda_malloc(GPU, UM, (void **)&d_Hx_r, size);
		cuda_malloc(GPU, UM, (void **)&d_Hy_r, size);
		cuda_malloc(GPU, UM, (void **)&d_Hz_r, size);
		cuda_malloc(GPU, UM, (void **)&d_Ex_i, size);
		cuda_malloc(GPU, UM, (void **)&d_Ey_i, size);
		cuda_malloc(GPU, UM, (void **)&d_Ez_i, size);
		cuda_malloc(GPU, UM, (void **)&d_Hx_i, size);
		cuda_malloc(GPU, UM, (void **)&d_Hy_i, size);
		cuda_malloc(GPU, UM, (void **)&d_Hz_i, size);
	}
}
